$("#id_articulo_text").addClass('form-control');
$("#unidades_div").hide();
function mostrarControlesSeries(mostrar)
{ 
  if(mostrar){
    $("#serieContainerId").show();
    $("#id_articulo_text, #id_clave_articulo").hide();
  }
  else{
    $("#id_articulo_text, #id_clave_articulo").show();
    $("#serieContainerId").hide();
  }
}
mostrarControlesSeries(false);

if($("#extra_mobile_btn:visible").length>0){
  $("#id_clave_articulo").hide();
  $("#id_articulo_text").show();
}



$('#manejarSeries, #manejarSeriesMobile').on("change", function(){
  mostrarControlesSeries(this.checked);
});

$('#chbx_modorapido').on("change", function(){
  if(this.checked){
    $("#id_clave_articulo").show();
    $("#id_articulo_text").hide();
  }
  else{
    $("#id_articulo_text").show();
    $("#id_clave_articulo").hide();
  }
});
/* Mostrar articulo */
function cargar_articulo( articulo_id, articulo_nombre)
{
  $('#id_articulo-deck').attr('style','');
  $('#id_articulo-deck').html('<span class="div hilight" data-value="'+articulo_id+'"><span style="display: inline;" class="remove div">X</span>'+articulo_nombre+'</span>');
  $('#id_articulo').html('<option selected="selected" value="'+articulo_id+'"></option>');
  $('#id_articulo_text').hide();
  $("#id_articulo").trigger( "change" );
  $("#id_unidades").focus();
}

function cerrar_inventario(){
  $.ajax({
      url:'/inventarios/close_inventario_byalmacen_view/', 
      type : 'get', 
      data:{
        'almacen_id' : $("#almacen_id").val(),
      }, 
      success: function(data){ 
        alert(data.mensaje);
        window.location = "/inventarios/almacenes/";
      },
      error: function() {
        },
    });
  
}
$('#span_alerta_unidades, #span_ya_ajustado, #span_sin_ajustado').hide();
    // $("#span_nombre_articulo").show();
$('#id_costo_unitario').val('');
$("#id_articulo_text").focus();

function cargar_opciones_clave(opciones){

  if (Object.keys(opciones).length > 0 ) {
    html_var = '';
    for (articulo in opciones)
    { 
      html_var = html_var + "<a href='#' class='clave_link'>" + articulo + "</a> " + opciones[articulo]+"<br>";
    }


    $("#opciones_clave_Modal").modal();
    $("#id_opciones_clave").html(html_var);
    $(".clave_link").on("click", function(){
      $("#id_clave_articulo").val($(this).text());
      $("#id_clave_articulo").trigger('change');
      $('#opciones_clave_Modal').modal('hide');
    });
  }
}

$("#id_clave_articulo").change(function(e){
  e.preventDefault();
  
  clave = $("#id_clave_articulo").val();
  if( clave != null && clave != '' ){
    $.ajax({
      url:'/inventarios/get_articulo_porclave/', 
      type : 'get', 
      data:{
        'clave': clave,
      }, 
      success: function(data){
          var opciones_clave =  data.opciones_clave;
          var articulo_nombre = data.articulo_nombre;
          var articulo_id = data.articulo_id;

          if (Object.keys(opciones_clave).length <= 0){
            if (articulo_nombre == ''){
              alert('No se encontro ningun articulo con la clave');
            }
            else{
              cargar_articulo(articulo_id, articulo_nombre);
            }
          // Si hay opciones por mostrar
          }else{
            cargar_opciones_clave(opciones_clave);
          }
      },
      error: function() {
        alert('fallo algo');
      },
    });
  }
  return false;
});
var show_mobile = false;
$("#extra_mobile_btn").on("click", function(){
  if (show_mobile == false){
    $("#extra_mobile").show();
    show_mobile = true;
  }else{
    $("#extra_mobile").hide();
    show_mobile = false;
  }

});

$("#id_articulo").change(function(){
  $('#id_costo_unitario').val('');
  $('#id_unidades').val('');
  
  if( $("#id_articulo").val() == null )
  {
    $('#span_alerta_unidades, #span_ya_ajustado, #span_sin_ajustado').hide();
    $("#id_clave_articulo").val('');
    $("#unidades_div").hide();
  }
  else
  {

    $.ajax({
      url:'/inventarios/get_existencia_articulo/', 
      type : 'get', 
      data:{
        'almacen': $("#almacen_nombre").val(), 
        'articulo_id': $("#id_articulo").val()[0]
      }, 
      success: function(data){ 
        $("#unidades_div").show();
        $('#span_alerta_unidades').html(data.existencias + " en existencia. <a tabindex='-1' href='#modal_movimientos_articulo' role='button' data-toggle='modal'><i class='icon-info-sign icon-white'></i></a> ");
        var ya_ajustado = data.ya_ajustado;
        if (ya_ajustado == true)
        {
          $('#span_alerta_unidades, #span_ya_ajustado').show();
          $('#span_sin_ajustado').hide();
        }
        else
        {  
          $('#span_alerta_unidades, #span_sin_ajustado').show();
          $('#span_ya_ajustado').hide();
        }
        $("#id_unidades").focus();
        
      },
      error: function() {
        alert('fallo algo');
      },

    });
  }
});

function add_existenciasarticulo_byajuste(){
  
  if ( $("#btn_agregar_articulosinexistencia").attr("disabled") == "disabled")
    return false

  var $ubicacion = $('#id_ubicacion');

  if($("#id_ubicacion:visible").length <= 0){
    var $ubicacion = $('#id_ubicacion_mobile');    
  }

  if ($ubicacion.val() == ''){
      alert("El campo ubicacion es obligatorio");
      if ($("#extra_mobile_btn:visible").length>0){
        $("#extra_mobile_btn").trigger("click");
      }

      $ubicacion.focus();
      return;
  }
  else if ($('#id_articulo option:selected').val() == undefined)
  {
    alert("El campo articulo es obligatorio");
    $("#id_articulo_text").focus();
    return;
  }
  else if ($('#id_unidades').val() == '')
  { 
    alert("El campo unidades es obligatorio");
    $("#id_unidades").focus();
    return;
  }
  else if ($.isNumeric($('#id_unidades').val()) == false )
  {
    alert("Unidades incorrectas");
    $("#id_unidades").focus();
    return;
  }
  // else if ($.isNumeric($('#id_costo_unitario').val()) == false){
  //   alert("costo incorrecto");
  //   $("#id_costo_unitario").focus();
  //   return;
  // }
  
  var entrada_id  = $("#hidden_entrada_id").val();
  var salida_id = $("#hidden_salida_id").val();
  var ubicacion = $("#id_ubicacion").val();
  var unidades = $("#id_unidades").val();
  // var costo_unitario = $('#id_costo_unitario').val();
  var articulo_id = $("#id_articulo").val()[0];
  var almacen_nombre =  $("#almacen_nombre").val();
  
  $.ajax({
      url:'/inventarios/agregar_existencia/', 
      type : 'get', 
      data:{
        'entrada_id':entrada_id,
        'salida_id':salida_id,
        'ubicacion':ubicacion,
        'unidades':unidades,
        'costo_unitario':0,
        'articulo_id':articulo_id,
        'almacen_nombre':almacen_nombre,
      }, success: function(data){
        var $articulo_tr = $("#articulo-"+data.articulo_id).parent().parent();
        if ($articulo_tr.length>0){
          $articulo_tr.children(":last").text(data.existencia);
          var temp = $articulo_tr.addClass("warning")[0]
          $articulo_tr.remove();
          $("#ultimos_articulos_contados tbody").prepend(temp);
        }else{  
          $("#ultimos_articulos_contados tbody").prepend("<tr class='warning'><td><input type='hidden' id='articulo-"+data.articulo_id +"' value='"+data.articulo_id+"'/> </td><td>"+data.articulo_nombre+"</td><td>"+data.existencia+"</td></tr>");
        }
        $(".remove:first").trigger("click");
        
        if($("#extra_mobile_btn:visible").length>0){
          if($("#chbx_modorapido:checked").length>0){
            $("#id_clave_articulo").show();
            $("#id_clave_articulo").focus();
            $("#id_articulo_text").hide();
          }
          else{
            $("#id_articulo_text").show();
            $("#id_articulo_text").focus();
            $("#id_clave_articulo").hide();
          }
        }

      },error: function() {
        alert('fallo algo');
      },
    });
}